#!/usr/bin/perl

# 20080124 PJ   0.1  jakobi@acm.org initial version
# copyright:  GPL v3 or later

sub usage{
   warn "@_\n" if @_;
   die "Usage: $0 <ls arguments> <snap id|snap path|*>\n       $0 -d . <snap id> # to view rsync backup path\n"
}

if ($ARGV[0] eq "--help") {
   usage();
}

$snap=pop;
chomp($hostname=`hostname`);
$BAK=$ENV{XFERBACKUPROOT};
$BAK="/disk2/automated-backup/compact/host.$hostname/rsync" 
   if not $BAK or not -d $BAK;

if ($snap=~m@^(\*|[ywmq]?\d+)(?:\.([a-z\d]+))?$@) {
   $snap=$1;
   $hostname=$2;
   if ($hostname) {
      $BAK=~s@/host\.[^/]+/rsync@@;
      if      (-d "$BAK/host.$hostname/rsync") {
         $BAK="$BAK/host.$hostname/rsync";
      } elsif (-d "$BAK/$hostname/rsync") {
         $BAK="$BAK/$hostname/rsync";
      } else {
         usage("no snap - cannot find rsync hierarchy");
      }
   }
   if ($snap ne "*") {
      $BAK="$BAK/$snap";
      -d "$BAK" or usage("no such snap $snap");
      $BAKPWD="$BAK$ENV{PWD}";
   }
} elsif (-d $snap and $snap=~m@^/@) {
   $BAK=$snap;
   $BAKPWD="$BAK$ENV{PWD}";
} else {
   usage("invalid snap specification");
}

for(@ARGV) {
   m!^-!                  and do{push @argv, $_; next};
   m!^/! and $snap ne "*" and do{push @argv, "$BAK$_"; next};
   m!^/!                  and do{push @argv, (glob("\Q$BAK\E/*\Q$_\E")); next};
             $snap ne "*" and do{push @argv, "$BAKPWD/$_"; next};
                              do{push @argv, (glob("\Q$BAK\E/*\Q$ENV{PWD}/$_\E")); next};
}

#exec "echo", @argv;
exec "ls", @argv;
